package com.example.gps_location;
import android.os.Bundle;
import android.provider.Settings;
import android.app.Activity;
import android.app.AlertDialog;
import android.view.Menu;
import android.view.View;
import android.widget.Toast;
import android.content.DialogInterface;
import android.content.Intent;

public class GPS_tracker extends Activity{
	Intent service;

	@Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
    }
    
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.activity_main, menu);
        return true;
    }
    
    public void onDestroy()
    {
    	super.onDestroy();
    }

    
    /** metoda sa zavola po staceni tlacidla Show Location */
    public void show_settings(View view) {
    	showSettingsAlert();
	}
    
    /** metoda sa zavola po staceni tlacidla Start again*/ 
    public void start_gpsService(View view){
    	start_gpsService();
    }
    
    /** metoda sa zavola po staceni tlacidla Start again*/
    public void start_gpsService() {
    	//ukazeme spravu o zacati zbierania dat
    	Toast.makeText(this, "Started getting location", Toast.LENGTH_LONG).show();
    	startService(new Intent(GPSTracker.MY_SERVICE));
	}
    
    /** metoda sa zavola po staceni tlacidla Stop tracking */
    public void stop_tracking(View view) {
    	try {
    		stopService(new Intent(GPSTracker.MY_SERVICE)); //zastavime service
    		//ukazeme spravu o vypnuti zbierania dat
    		Toast.makeText(this, "Stopped getting location", Toast.LENGTH_SHORT).show();
        } catch (Exception e) {
        	Toast.makeText(this, "Service doesnt exist", Toast.LENGTH_SHORT).show();
        }
	}
    
    /** metoda sa zavola po staceni tlacidla Show settings */
    public void showSettingsAlert(){
        AlertDialog.Builder alertDialog = new AlertDialog.Builder(GPS_tracker.this);
        // nazov dialog okna
        alertDialog.setTitle("GPS settings");
        // sprava dialog okna
        alertDialog.setMessage("GPS is not enabled. Do you want to go to settings menu?");
        // po stlaceni Settings button
        alertDialog.setPositiveButton("Settings", new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog,int which) {
                Intent intent = new Intent(Settings.ACTION_LOCATION_SOURCE_SETTINGS);
                GPS_tracker.this.startActivity(intent);
            }
        });
        // po stlaceni tlacidla cancel
        alertDialog.setNegativeButton("Cancel", new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog, int which) {
            dialog.cancel();
            }
        });
        // ukazeme dialog okno
        alertDialog.show();
    }
}