
import java.util.Random;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import jsc.distributions.Pareto;
import jsc.distributions.Logistic;

public class ACRM_model { 
	public static Random rnd=new Random();
	public static Logistic rnd1;
	public static Random speed_rnd;
	public static Pareto pdf;
	public static Pareto aim;
	public static Random limit_rnd=new Random();
	public static File dir=new File("ACRM_model");
	public static int aim_lat;
	public static int aim_long;
	public static int max_lat = 5000, 
		      max_long = 5000;
	public static int min_lat = 0, 
		      min_long = 0;
	public static int limit=0;
	public static double max_distance=3000;
	public static double min_distance=23;
	public static double max_angle=180;
	public static double min_angle=-180;
	public static double max_aim=10000;
	
static public void main(String args[]) throws Exception {
  int poc=0;
  
  BufferedReader br;
  File segfile=new File("total_Time.txt");
  br = new BufferedReader(new FileReader(segfile));
  String num="";
  String[] tokens;
  num=br.readLine();
  br.close();
  tokens=num.split("[;]+");
  
  if (!dir.exists()) {
		dir.mkdir(); 
  } 
	  
  while (poc<948){
	  BufferedWriter bw = new BufferedWriter(new FileWriter(new File(dir,"1_"+poc+"_A.txt")));
	  int time=0;
	  int part_time=0;
      int new_lat=0,new_log=0;
      max_distance=3000;
      min_distance=23;
      max_angle=180;
  	  min_angle=-180;
      max_aim=10000;
      double distance;
      rnd1 = new Logistic(0, 39.1463) ;
      speed_rnd = new Random();
      limit=Integer.parseInt(tokens[poc]);
       
      int lat=rnd.nextInt((int)max_lat),log=rnd.nextInt((int)max_long);
      
      aim=new Pareto(244.9597,1.3486);  //scale/location,shape
      max_aim=aim.cdf(max_aim);
      int aim_lat=lat+(int)(aim.inverseCdf(Math.random()*max_aim)*(-1*Math.round(Math.random()))),aim_log=log+(int)(aim.inverseCdf(Math.random()*max_aim)*(-1*Math.round(Math.random())));
      pdf=new Pareto(22.2567,0.9020);
      min_distance=pdf.cdf(min_distance);
      max_distance=pdf.cdf(max_distance);
      
      min_angle=rnd1.cdf(min_angle);
      max_angle=rnd1.cdf(max_angle);
      bw.append(0+"|"+lat+"|"+log+";");
      
      int angle=0;
      while (time<limit){
    	  distance=pdf.inverseCdf(min_distance+Math.random()*(max_distance-min_distance));
    	  if (distance<500){
    		  part_time=(int)(30.55*Math.pow(distance, (1-0.89)));
    	  } else {
    		  part_time=(int)(0.76*Math.pow(distance, (1-0.28)));
    	  } 
          if (aim_lat-lat>0) angle=(int)Angle(new double[]{lat+10,log},new double[]{aim_lat,aim_log},new double[]{lat,log});    
          else angle=360-(int)Angle(new double[]{lat+10,log},new double[]{aim_lat,aim_log},new double[]{lat,log});
    	  angle=360+(angle+(int)rnd1.inverseCdf(min_angle+Math.random()*(max_angle-min_angle)));
    	  System.out.println(angle);
    	  new_lat=(int)(lat+Math.cos(Math.toRadians(angle))*distance);
    	  new_log=(int)(log+Math.sin(Math.toRadians(angle))*distance);
    	  
    	  if (time+part_time<=limit) {
			time+=part_time;
		  }
		  else {
			double part=(limit-time)/(double)part_time;
  			new_lat=(int)(lat+(new_lat-lat)*part);
  			new_log=(int)(log+(new_log-log)*part);
  			part_time=(limit-time);
  			time=limit;
		  }
		  bw.append(part_time+"|"+new_lat+"|"+new_log+";");
		  lat=new_lat;
		  log=new_log;
	 }
      bw.close();
      System.out.println(poc);
      poc++;
 }
}

//ratame uhol medzi bodmi A,C,B
private static double Angle(double[] pointA, double[] pointB, double[] pointC){	
	double d12=Distance(pointC,pointA);
	double d13=Distance(pointC,pointB);
	double d23=Distance(pointA,pointB);
	return Math.round((180.0 * Math.acos(((d12*d12)+(d13*d13)-(d23*d23))/(double)(2*d12*d13)))/Math.PI) ;		
}

//ratame vzdialenost medzi bodom A a B
private static double Distance(double[] pointA, double[] pointB){
	    
	double d1 = pointA[0] - pointB[0];
	double d2 = pointA[1] - pointB[1];

	return Math.sqrt(d1 * d1 + d2 * d2);
}

}