import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.LinkedList;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JPanel;

@SuppressWarnings("serial")

public class LinesComponent extends JComponent{
	
private static int pocet=42;   //celkovy pozet suborov od dobrovolnikov, pomocna premenna pri zacyklenom vykreslovani ciest
private static ArrayList<gpsPoint> points; //arraylist bodov prave sledovanej cesty
private static int odd=2;   //premenna odstupu pri obdlznikovej metode zjednodusenia dat
private static double angle=160.0;  //premenna hranice pre uhlovu metodu zjednodusovania dat
private static double min_lat,min_long;    //minimalna latitude a longitude v konkretne sledovanom tracku
private static double max_lat,max_long;    //maximalna latitude a longitude v konkretne sledovanom tracku
private static int width=600;             //sirka okna prevykreslovanie tracku
private static int height=600;			 //vyska okna prevykreslovanie tracku
private static double mult=1;           //multiplikator pre skalovanie tracku do velkosti nasho okna
private static Color newColor = new Color(0,0,0);  //farba cesty
private static int sub=0;				//pocet trackov spravenych jednym uzivatelom (v jednom velkom subore dat zo servera)
private static int segment=0;			//konkretne sledovany track...jeho identifikacne cislo medzi vsetkymi trackmi
private static File dir;					//priecinok v ktorom najdeme subory a do ktoreho zapiseme upravene subory
private static int filename=1;			//nazov konkretneho spracovaneho suboru s trackmi
private static String dirname="output";  //priecinok so subormi (output pre realne data alebo nazov modelu pre simulovane data)



/** metoda pre vypocet vzdialenosti bodu C od usecky(pre isSegment true) alebo priamky(pre hodnotu isSEgment false) AB*/
private static double LineToPointDistance2D(double[] pointA, double[] pointB, double[] pointC, boolean isSegment)
{
    double dist = CrossProduct(pointA, pointB, pointC) / Distance(pointA, pointB);
    if (isSegment)
    {
        double dot1 = DotProduct(pointA, pointB, pointC);
        if (dot1 > 0) 
            return Distance(pointB, pointC);

        double dot2 = DotProduct(pointB, pointA, pointC);
        if (dot2 > 0) 
            return Distance(pointA, pointC);
    }
    return Math.abs(dist);
}


	//vypocet dot product AB . AC
private static double DotProduct(double[] pointA, double[] pointB, double[] pointC)
	{
	    double[] AB = new double[2];
	    double[] BC = new double[2];
	    AB[0] = pointB[0] - pointA[0];
	    AB[1] = pointB[1] - pointA[1];
	    BC[0] = pointC[0] - pointB[0];
	    BC[1] = pointC[1] - pointB[1];
	    double dot = AB[0] * BC[0] + AB[1] * BC[1];

	    return dot;
	}

	//vypocet cross product AB x AC
private static double CrossProduct(double[] pointA, double[] pointB, double[] pointC)
	{
	    double[] AB = new double[2];
	    double[] AC = new double[2];
	    AB[0] = pointB[0] - pointA[0];
	    AB[1] = pointB[1] - pointA[1];
	    AC[0] = pointC[0] - pointA[0];
	    AC[1] = pointC[1] - pointA[1];
	    double cross = AB[0] * AC[1] - AB[1] * AC[0];

	    return cross;
	}

	//vypocet vzdialenosti A od B
private static double Distance(double[] pointA, double[] pointB)
	{
	    double d1 = pointA[0] - pointB[0];
	    double d2 = pointA[1] - pointB[1];

	    return Math.sqrt(d1 * d1 + d2 * d2);
	}


	/** metoda pre vypocet uhlu medzi useckami AC a BC*/
	private static double Angle(double[] pointA, double[] pointB, double[] pointC){
		double d12=Distance(pointC,pointA);
		double d13=Distance(pointC,pointB);
		double d23=Distance(pointA,pointB);
		return Math.round((180.0 * Math.acos(((d12*d12)+(d13*d13)-(d23*d23))/(double)(2*d12*d13)))/Math.PI) ;		
	}
	
	/** metoda na prevod 2 gps suradnic na vzdialenost v metroch*/
	public static double gps2m(double lat_a, double lng_a, double lat_b, double lng_b) {
	    double pk = (double) (180/Math.PI);

	    double a1 = lat_a / pk;
	    double a2 = lng_a / pk;
	    double b1 = lat_b / pk;
	    double b2 = lng_b / pk;

	    double t1 = Math.cos(a1)*Math.cos(a2)*Math.cos(b1)*Math.cos(b2);
	    double t2 = Math.cos(a1)*Math.sin(a2)*Math.cos(b1)*Math.sin(b2);
	    double t3 = Math.sin(a1)*Math.sin(b1);
	    double tt = Math.acos(t1 + t2 + t3);
	   
	    return 6366738*tt;
	}

//specialna trieda nadefinovana pre gps bod (obsahuje latitude, longitude a cas)
public static class gpsPoint{
	private double lat;
	private double log;
	private int time=0;
	
	public gpsPoint(int time, double lat,double log){
		this.time=time;
		this.lat=lat;
		this.log=log;
	}
	
	public void setLog(double log){
		this.log=log;
	}
	public void setTime(int time){
		this.time=time;
	}
	public void setLat(double lat){
		this.lat=lat;
	}
	public double getLog(){
		return this.log;
	}
	public double getLat(){
		return this.lat;
	}
	public int getTime(){
		return this.time;
	}
}

//trieda pre ciary(cesty), ktore budeme vykreslovat
private static class Line{
    final int x1; 
    final int y1;
    final int x2;
    final int y2;   
    final Color color;

    public Line(int x1, int y1, int x2, int y2, Color color) {
        this.x1 = x1;
        this.y1 = y1;
        this.x2 = x2;
        this.y2 = y2;
        this.color = color;
    }               
}

//vsetky ciary, ktore chceme vykreslit v spojenom zozname
private final LinkedList<Line> lines = new LinkedList<Line>();

//pridanie ciary do zoznamu vykreslovanych ciar (bez konretnej farby)
public void addLine(int x1, int x2, int x3, int x4) {
    addLine(x1, x2, x3, x4, Color.green);
}

//pridanie ciary do zoznamu vykreslovanych ciar s urcenou konretnou farbou
public void addLine(int x1, int x2, int x3, int x4, Color color) {
    lines.add(new Line(x1,x2,x3,x4, color));        
    repaint();
}

//vycistenie zoznamu ciar
public void clearLines() {
    lines.clear();
    repaint();
}

//vykreslenie ciar na plochu
@Override
protected void paintComponent(Graphics g) {
    super.paintComponent(g);
    for (Line line : lines) {
        g.setColor(line.color);
        g.drawLine(line.x1, line.y1, line.x2, line.y2);
    }
}

final static LinesComponent comp = new LinesComponent();


public static void main(String[] args) throws Exception {
	
	points=new ArrayList<gpsPoint>();
	
	JFrame testFrame = new JFrame();
    testFrame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
    comp.setPreferredSize(new Dimension(height,width));
    testFrame.getContentPane().add(comp, BorderLayout.CENTER);
    JPanel buttonsPanel = new JPanel();
    JButton newLineButton = new JButton("New Line");
    JButton clearButton = new JButton("Clear");
    JButton nextButton = new JButton("Next Segment");
    JButton prevButton = new JButton("Previous Segment");
    JButton originalButton = new JButton("Original");
    JButton smoothButton = new JButton("Smooth");
    JButton angleButton = new JButton("Angle Smooth");
    buttonsPanel.add(newLineButton);
    buttonsPanel.add(clearButton);
    buttonsPanel.add(nextButton);
    buttonsPanel.add(prevButton);
    buttonsPanel.add(originalButton);
    buttonsPanel.add(smoothButton);
    buttonsPanel.add(angleButton);
    testFrame.getContentPane().add(buttonsPanel, BorderLayout.SOUTH);  
    
    //celkovy pocet trackov
    sub=948;
    dir = new File (dirname);
	if (!dir.exists()) {
		dir.mkdir(); 
	}
	
	/*
	 * tuto cast sme pouzili na rozbitie nasich suborov od dobrovolnikov na samostatne tracky
	 * 
    sub=0;
    segment=0;
    File temp_file;
    while(filename<=pocet){
		temp_file=new File (dir,filename+"_"+segment+"_A.txt");
		if (!temp_file.exists()) {
    		System.out.println(filename+"_"+segment+"_A.txt doesnt exist");
    		filename++;;
    		continue;
    	} else {
    //	split_file(filename);
    	read_points("_A");
    	segment++;
    	System.out.println(segment);
    	}
    }
  */  
	
	
	//precitaj body z konkretneho tracku @segment po uhlovej uprave dat(to je definovane hodnotou "_A") do arraylistu points
	read_points("_A");
	
	//tlacidlo na vykreslenie ciar medzi bodmi konkretneho tracku pohybu (arraylist points)
	newLineButton.addActionListener(new ActionListener() {
        @Override
        public void actionPerformed(ActionEvent e) {
            comp.clearLines();
            	for (int i=0;i<points.size()-1;i++)
                {
            		//posunutie bodu o min_latitde a min_longitude, aby som sa dostala do bodu (0,0) a preskalovanie multiplikatorom mult
                	comp.addLine((int)((points.get(i).getLat()-min_lat)*mult), (int)((points.get(i).getLog()-min_long)*mult), 
                			(int)((points.get(i+1).getLat()-min_lat)*mult), (int)((points.get(i+1).getLog()-min_long)*mult), newColor);
                }
        }
    });
	
	//tlacidlo na vymazanie ciar a plochy
    clearButton.addActionListener(new ActionListener() {

        @Override
        public void actionPerformed(ActionEvent e) {
            comp.clearLines();
        }
    });
    
  //tlacidlo pre prejdenie na dalsi track/segment (zacyklene) a precitanie bodov
    nextButton.addActionListener(new ActionListener() {

        @Override
        public void actionPerformed(ActionEvent e) {
        	segment=(segment+1)%sub;
        	if (!(new File (dir,filename+"_"+segment+"_A.txt")).exists()) {
        		filename=(filename%pocet)+1;
    		}
            try{
            	read_points("_A");
            } catch(Exception e1){
				e1.printStackTrace();
            }
        }
    });
    
  //tlacidlo pre prejdenie na dalsi track/segment (zacyklene) a precitanie bodov
    prevButton.addActionListener(new ActionListener() {
        @Override
        public void actionPerformed(ActionEvent e) {
            segment=((segment-1)+sub)%sub;
    		if (!(new File (dir,filename+"_"+segment+"_A.txt")).exists()) {
        		if (filename==1) filename=pocet;
        		else filename--;
    		}
            try{
            	read_points("_A");
            } catch(Exception e1){
				e1.printStackTrace();
            }
        }
    });
    
    //nacitanie tracku po oblznikovej metode
    smoothButton.addActionListener(new ActionListener() {
        @Override
        public void actionPerformed(ActionEvent e) {
            try{
            	read_points("_U");
            } catch(Exception e1){
				e1.printStackTrace();
            }
            System.out.println("smooth "+mult);
        }
    });
    
  //nacitanie originalneho tracku
    originalButton.addActionListener(new ActionListener() {
        @Override
        public void actionPerformed(ActionEvent e) {
            try{
            	read_points("");
            } catch(Exception e1){
				e1.printStackTrace();
            }
        }
    });
    
  //nacitanie tracku po uhlovej metode
    angleButton.addActionListener(new ActionListener() {
        @Override
        public void actionPerformed(ActionEvent e) {
            try{
            	read_points("_A");
            } catch(Exception e1){
				e1.printStackTrace();
            }
        }
    });
    
    testFrame.pack();
    testFrame.setVisible(true);
}


/**metoda na rozdelenia suboru z GPS aplikacie na male jednotlive tracky, @sfile je nazov suboru, ktory chceme rozdelit*/
public static void split_file(String sfile) throws Exception{
	BufferedReader br=new BufferedReader(new FileReader(new File(dir,sfile+".txt")));
	String num="";
	String[] tokens;
	num=br.readLine();
	br.close();
	tokens=num.split("[;]+"); //nacitane vsetky body
	int j=0;
	int start=0;  //zaciatok tracku
	int time=0;   //cas medzi dvoma bodmi
	double dist=0;  //vzdialenost medzi dvoma bodmi
	double speed=0;  //rychlost medzi dvoma bodmi
	String[] temp;   //bod v tvare time|longitude|latitude
	String[] temp1;
	while(j<tokens.length){
		temp=tokens[j].split("[|]+"); 
		//ak je to bod  zistime rychlost
		if (j>0){ 
			temp1=tokens[j-1].split("[|]+");
			if (temp1.length==3 && temp.length==3) {
				dist=gps2m(Double.parseDouble(temp1[1]),Double.parseDouble(temp1[2]),Double.parseDouble(temp[1]),Double.parseDouble(temp[2]));
				time=Integer.parseInt(temp[0])-Integer.parseInt(temp1[0]);
				speed=((int)((dist/(double)time)*1000))/(double)1000;
			}
		}
		//ak narazime na RESET alebo rychlost vacsiu ako 55m/s a mame aspon 10 bodov spravime si novy track
		if ((temp.length<3) || (j==tokens.length-1) || ((j!=start) && ((time<0) || (speed>55) || (speed<=0)))){
			if (j-start>=10) {
				File actualFile = new File (dir, filename+"_"+sub+".txt");
				BufferedWriter bw=new BufferedWriter(new FileWriter(actualFile));
				bw.write("");
				for (int i=start;i<j;i++)
	            {
	            	bw.append(""+tokens[i]+";");
	            }
				bw.close();
				//momentalny track nastavime na jeho celkove ohodnotenie
				segment=sub;
				//precitame body do struktury points, s ktorou sa nam lepsie pracuje
				read_points("");
				//pouzijeme oblznikovu metodu
				smooth_points();
				//nacitame body po obdlznikovej metode
				read_points("_U");
				//pouzijeme uhlovu metodu
				angle_points();
				//nacitat body po uhlovej metode
				read_points("_A");
				System.out.println("Finished spliting file "+filename+"_"+sub+" points "+points.size());
				//zvisenie poctu celkoveho poctu trackov
				sub++;
			}
			//nastavime novy start pre track. ak tam bol RESET tak na j+1(dalsi bod), ak to bolo koli rychlosti tak na j(momentalny bod) 
			if (temp.length<3) start=j+1; else start=j;
		}
		j++;
	}
}

/**metoda na nacitanie bodou zo suboru momentalneho tracku segment do struktury points
 * @dopl urcuje ci chceme nacitat original track ""/ po  obdlzikovej metode "U"/ uhlovej metode "_A"
 * */
public static void read_points(String dopl) throws Exception{
		min_lat=2000000;min_long=2000000;
		max_lat=-2000000;max_long=-2000000;
		points.clear();
		BufferedReader br;
		 File segfile;
		segfile=new File(dir,filename+"_"+segment+""+dopl+".txt");
        br = new BufferedReader(new FileReader(segfile));
    	String num="";
    	String[] tokens;
    	num=br.readLine();
    	br.close();
    	tokens=num.split("[;]+");
    	int j=0;
    	double lat=0,log=0;
    	String[] temp;
    	while(j<tokens.length){
    		temp=tokens[j].split("[|]+");
    		if (temp.length==3){
    			int time=Integer.parseInt(temp[0]);
    		    lat=Double.parseDouble(temp[1]);
    		    log=Double.parseDouble(temp[2]);
    		    	if (lat<min_lat) {min_lat=lat;}
    		    	if (lat>max_lat) {max_lat=lat;}
    		    	if (log<min_long) {min_long=log;}
    		    	if (log>max_long) {max_long=log;}
    		    	points.add(new gpsPoint(time,lat,log));
    		    	//points.add(new gpsPoint(lat,log));
    		}
    		j++;
    	}
    	//podla min_latitude,max_latitude, min_longitude, max_longitude a velkosti plochy vykreslovania height, width zistime parameter skalovania
    	if ((max_lat-min_lat)>(max_long-min_long)) mult=(double)height/(double)(max_lat-min_lat); else mult=(double)width/(double)(max_long-min_long);
    	System.out.println(filename+"_"+segment+ " Finished reading points "+points.size());
}


/**metoda na upravenie bodov v arraliste points obdlznikovou metodou a ich zapisanie do suboru @filename_@segment"_U.txt"
 * body si najprv prevedieme z gps do suradnicoveho systemu s metrami pomocou metody gps2m
 * metoda ide od prveho bodu A(bod 1), vezme dalsie dva body C(bod 2),B(bod 3) a zisti vzdialenost  bodu C od usecky AB
 * ak je tato vdialenost vacsia ako parameter @odd, tak bod 2 preskocime (vyhodime)
 * zaroven si v tejto metode ratame podmieneny uhol do suboru s koncovkou AD (angle distribution)
 * */
public static void smooth_points() throws Exception{
	boolean w_append;
	File actualFile = new File (dir, filename+"_"+segment+"_U.txt");
	BufferedWriter bw=new BufferedWriter(new FileWriter(actualFile));
	bw.write("");
	File actualFile1 = new File (dir,"total_AD.txt");
	if (!actualFile1.exists())
		w_append=false;
	else w_append=true;
	BufferedWriter bw1=new BufferedWriter(new FileWriter(actualFile1,w_append));
	double ang;
	
	double[] A = new double[4];
    double[] B = new double[4];
    double[] C = new double[4];
    double[] D = new double[3];
    A[0]=(int)gps2m(min_lat,points.get(0).getLog(),(points.get(0).getLat()),points.get(0).getLog());
	A[1]=(int)gps2m(points.get(0).getLat(),min_long,points.get(0).getLat(),(points.get(0).getLog()));
	A[2]=points.get(0).getTime();
	A[3]=0;
    bw.append((int)A[2]+"|"+(int)A[0]+"|"+(int)A[1]+";");
	C[0]=(int)gps2m(min_lat,points.get(1).getLog(),(points.get(1).getLat()),points.get(1).getLog());
	C[1]=(int)gps2m(points.get(1).getLat(),min_long,points.get(1).getLat(),(points.get(1).getLog()));
	C[2]=points.get(1).getTime();
	C[3]=1;
	D[0]=(int)gps2m(min_lat,points.get(points.size()-1).getLog(),(points.get(points.size()-1).getLat()),points.get(points.size()-1).getLog());
	D[1]=(int)gps2m(points.get(points.size()-1).getLat(),min_long,points.get(points.size()-1).getLat(),(points.get(points.size()-1).getLog()));
    D[2]=points.get(points.size()-1).getTime();
	
	double dist;
	for (int i=2;i<points.size();i++)
    {
		B[0]=(int)gps2m(min_lat,points.get(i).getLog(),(points.get(i).getLat()),points.get(i).getLog());
		B[1]=(int)gps2m(points.get(i).getLat(),min_long,points.get(i).getLat(),(points.get(i).getLog()));
		B[2]=points.get(i).getTime();
		B[3]=i;
		
		ang=Angle(C,D,A);
	    bw1.append(ang+";");
	    bw1.append(((-1)*ang)+";");
	   
		dist=LineToPointDistance2D(A,B,C,true);
		if (dist>odd){
			bw.append((int)C[2]+"|"+(int)C[0]+"|"+(int)C[1]+";");
			A[0]=C[0];A[1]=C[1];A[2]=C[2];A[3]=C[3];
			
		} 
		C[0]=B[0];C[1]=B[1];C[2]=B[2];C[3]=B[3];
    }
	bw.append((int)B[2]+"|"+(int)B[0]+"|"+(int)B[1]+";");
	bw.close();
	bw1.close();
}


/**metoda na upravenie bodov v arraliste points uhlovou metodou a ich zapisanie do suboru @filename_@segment"_A.txt"
 * metoda ide od prveho bodu A(bod 1), vezme dalsie dva body C(bod 2),B(bod 3) a zisti vzdialenost  uhol pri bode 2
 * ak je tento uhol vacsi ako parameter @angle, tak bod 2 preskocime (vyhodime)
 * */
public static void angle_points() throws Exception{	

	File actualFile1 = new File (dir,filename+"_"+ segment+"_A.txt");
	BufferedWriter bw1=new BufferedWriter(new FileWriter(actualFile1));
	bw1.write("");
	
	double[] A = new double[4];
    double[] B = new double[4];
    double[] C = new double[4];
	A[0]=(int)points.get(0).getLat();
	A[1]=(int)points.get(0).getLog();
	A[2]=points.get(0).getTime();
	A[3]=0;
	bw1.append("0|"+(int)A[0]+"|"+(int)A[1]+";");
	C[0]=(int)points.get(1).getLat();
	C[1]=(int)points.get(1).getLog();
	C[2]=points.get(1).getTime();
	C[3]=1;
	double ang;
	for (int i=2;i<points.size();i++)
    {
		B[0]=(int)points.get(i).getLat();
		B[1]=(int)points.get(i).getLog();
		B[2]=points.get(i).getTime();
		B[3]=i;
		
		ang=Angle(A,B,C);
		if (ang<angle){
			bw1.append((int)(C[2]-A[2])+"|"+(int)C[0]+"|"+(int)C[1]+";");	
			A[0]=C[0];A[1]=C[1];A[2]=C[2];A[3]=C[3];
		}
		C[0]=B[0];C[1]=B[1];C[2]=B[2];C[3]=B[3];
    }
	bw1.append((int)(C[2]-A[2])+"|"+(int)C[0]+"|"+(int)C[1]+";");	
	bw1.close();
}

}