import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;

public class track_properties {
	
private static int pocet=42;   //celkovy pozet suborov od dobrovolnikov, pomocna premenna pri zacyklenom vykreslovani ciest
private static ArrayList<gpsPoint> points; //arraylist bodov prave sledovanej cesty
private static final int variance=25;  //premenna dosahu signalu pre vlastnosti celkove pokrytie a pocet susedov
private static final int variance2=(variance*variance);  //pre odbremennenie sa ratania odmocniny a neskor druhej mocniny
private static int min_lat,min_long;    //minimalna latitude a longitude v konkretne sledovanom tracku
private static int max_lat,max_long;    //maximalna latitude a longitude v konkretne sledovanom tracku
private static int segment=0;			//konkretne sledovany track...jeho identifikacne cislo medzi vsetkymi trackmi
private static File dir;					//priecinok v ktorom najdeme subory a do ktoreho zapiseme upravene subory
private static int filename=1;			//nazov konkretneho spracovaneho suboru s trackmi

/** metoda pre vypocet vzdialenosti bodu C od usecky(pre isSegment true) alebo priamky(pre hodnotu isSEgment false) AB
 * pozor vraciame druhu mocninu vzdialenosti pre urychlenie vypoctu
 * */
private static long LineToPointDistance2D(int[] pointA, int[] pointB, int[] pointC, boolean isSegment)
{
	long cross_prod=CrossProduct(pointA, pointB, pointC);
	long distAB=Distance(pointA, pointB); 
	long dist;
	if (distAB>0){
		dist = (long)(cross_prod*(cross_prod/ (double)distAB));
    } else dist=Distance(pointB, pointC);
    
	if (isSegment)
    {
        long dot1 = DotProduct(pointA, pointB, pointC);
        if (dot1 > 0) 
            return Distance(pointB, pointC);

        long dot2 = DotProduct(pointB, pointA, pointC);
        if (dot2 > 0) 
            return Distance(pointA, pointC);
    }
    return dist;
}

//vypocet dot product AB . AC
private static long DotProduct(int[] pointA, int[] pointB, int[] pointC)
	{
	    int[] AB = new int[2];
	    int[] BC = new int[2];
	    AB[0] = pointB[0] - pointA[0];
	    AB[1] = pointB[1] - pointA[1];
	    BC[0] = pointC[0] - pointB[0];
	    BC[1] = pointC[1] - pointB[1];
	    long dot = AB[0] * BC[0] + AB[1] * BC[1];

	    return dot;
	}

//vypocet cross product AB x AC
private static long CrossProduct(int[] pointA, int[] pointB, int[] pointC)
	{
	    int[] AB = new int[2];
	    int[] AC = new int[2];
	    AB[0] = pointB[0] - pointA[0];
	    AB[1] = pointB[1] - pointA[1];
	    AC[0] = pointC[0] - pointA[0];
	    AC[1] = pointC[1] - pointA[1];
	    long cross = AB[0] * AC[1] - AB[1] * AC[0];

	    return cross;
	}

//vypocet vzdialenosti A od B
private static long Distance(int[] pointA, int[] pointB)
	{
	    int d1 = pointA[0] - pointB[0];
	    int d2 = pointA[1] - pointB[1];

	    return (d1 * d1 + d2 * d2);
	}

//specialna trieda nadefinovana pre gps bod (obsahuje latitude, longitude a cas)	
public static class gpsPoint{
	private int lat;
	private int log;
	private int time=0;
	
	public gpsPoint(int time, int lat,int log){
		this.time=time;
		this.lat=lat;
		this.log=log;
	}
	public gpsPoint(int lat,int log){
		//this.time=time;
		this.lat=lat;
		this.log=log;
	}
	public void setLog(int log){
		this.log=log;
	}
	public void setTime(int time){
		this.time=time;
	}
	public void setLat(int lat){
		this.lat=lat;
	}
	public int getLog(){
		return this.log;
	}
	public int getLat(){
		return this.lat;
	}
	public int getTime(){
		return this.time;
	}
}


public static void main(String[] args) throws Exception {
	points=new ArrayList<gpsPoint>();

    dir = new File ("ACRM_model");
	if (!dir.exists()) {
		dir.mkdir(); 
	}
    File temp_file;
	while(filename<=pocet){
		temp_file=new File (dir,filename+"_"+segment+"_A.txt");
		if (!temp_file.exists()) {
    		System.out.println(filename+"_"+segment+"_A.txt doesnt exist");
    		filename++;
    		continue;
    	} else {
    	
    	read_points("_A");
    	//write_points("_A");
    	distance_distribution();
    	diffusion_distribution();
    	coverage1();
    	segment++;
    	System.out.println(segment);
    	}
    }
}


/**metoda na nacitanie bodou zo suboru momentalneho tracku segment do struktury points
 * @dopl urcuje ci chceme nacitat original track ""/ po  obdlzikovej metode "U"/ uhlovej metode "_A"
 * */
public static void read_points(String dopl) throws Exception{
		min_lat=2000000;min_long=2000000;
		max_lat=-2000000;max_long=-2000000;
		points.clear();
		BufferedReader br;
		 File segfile;
		segfile=new File(dir,filename+"_"+segment+""+dopl+".txt");
        br = new BufferedReader(new FileReader(segfile));
    	String num="";
    	String[] tokens;
    	num=br.readLine();
    	br.close();
    	tokens=num.split("[;]+");
    	int j=0;
    	String[] temp;
    	while(j<tokens.length){
    		temp=tokens[j].split("[|]+");
    		if (temp.length==3){
    			int time=Integer.parseInt(temp[0]);
    		    int lat=Integer.parseInt(temp[1]);
    		    int log=Integer.parseInt(temp[2]);
    		    	if (lat<min_lat) {min_lat=lat;}
    		    	if (lat>max_lat) {max_lat=lat;}
    		    	if (log<min_long) {min_long=log;}
    		    	if (log>max_long) {max_long=log;}
    		    	points.add(new gpsPoint(time,lat,log));
    		}
    		j++;
    	}
    	System.out.println(filename+"_"+segment+ " Finished reading points "+points.size());
}


/**metoda, ktora premapuje tracky do laveho dolneho rohu do oblasit (0,0) az (max_lat-min_lat,max_long-min_long) a prepise subor s trackom */
public static void write_points(String dopl) throws Exception{
	BufferedWriter bw;
	File segfile;
	segfile=new File(dir,filename+"_"+segment+""+dopl+".txt");
    bw = new BufferedWriter(new FileWriter(segfile));
    bw.write("");
    int j=0;
	
	while(j<points.size()){
		bw.append(""+(int)points.get(j).getTime()+"|"+(int)(points.get(j).getLat()-min_lat)+"|"+(int)(points.get(j).getLog()-min_long)+";");
		j++;
	}
	System.out.println(filename+"_"+segment+ " Finished writing points "+points.size());
	bw.close();
}

/**metoda ratajuca vlastnost jednotlivych ciest, rychlost, celkovu trajektoriu, celkovy cas a zapise to vsetko do samostatnych suborov */
public static void distance_distribution() throws Exception{	
	boolean w_append;
	File actualFile1 = new File (dir,"total_Distance_"+dir.getName()+".txt");
	if (!actualFile1.exists())
		w_append=false;
	else w_append=true;
	BufferedWriter bwd=new BufferedWriter(new FileWriter(actualFile1,w_append));
	File actualFile2 = new File (dir,"total_Speed_"+dir.getName()+".txt");
	if (!actualFile2.exists())
		w_append=false;
	else w_append=true;
	BufferedWriter bws=new BufferedWriter(new FileWriter(actualFile2,w_append));
	File actualFile3 = new File (dir,"total_Trajectory_"+dir.getName()+".txt");
	if (!actualFile3.exists())
		w_append=false;
	else w_append=true;
	BufferedWriter bwt=new BufferedWriter(new FileWriter(actualFile3,w_append));
	
	File actualFilet = new File (dir,"total_Time_"+dir.getName()+".txt");
	if (!actualFilet.exists())
		w_append=false;
	else w_append=true;
	BufferedWriter bwr_time=new BufferedWriter(new FileWriter(actualFilet,w_append));
	
	int[] A = new int[3];
    int[] B = new int[3];
	A[0]=(points.get(0).getLat());
	A[1]=(points.get(0).getLog());
	A[2]=points.get(0).getTime();
	int time=0;
	int dist;
	int trajectory=0;
	double speed;
	
	for (int i=1;i<points.size();i++)
    {
		B[0]=(points.get(i).getLat());
		B[1]=(points.get(i).getLog());
		B[2]=(points.get(i).getTime());
		
	    dist =(int)(Math.sqrt(Distance(A,B)));
	    trajectory+=dist;
	    speed=((int)((dist/(double)B[2])*1000))/(double)1000;
		time+=(int)B[2];
	    A[0]=B[0];
		A[1]=B[1];
		A[2]=B[2];
	    
		bwd.append(""+dist+";");
		bws.append(""+speed+";");
    }
	bwt.append(trajectory+";");
	bwt.close();
	bwr_time.append(""+time+";");
	bwr_time.close();
	bwd.close();
	bws.close();
}


/**metoda pocitajuca vlastnost rozptyl a tuto vlastnost pre kazdy track zapise do jedneho suboru */
public static void diffusion_distribution() throws Exception{	
	boolean w_append;

	File actualFile2 = new File (dir,"total_Diff_"+dir.getName()+".txt");
	if (!actualFile2.exists())
		w_append=false;
	else w_append=true;
	BufferedWriter bwr=new BufferedWriter(new FileWriter(actualFile2,w_append));
	
	int[] A = new int[3];
    int[] B = new int[3];
	A[0]=(points.get(0).getLat());
	A[1]=0;
	A[2]=points.get(0).getTime();
	
	B[0]=(points.get(points.size()-1).getLat());
	B[1]=0;
	B[2]=points.get(points.size()-1).getTime();

	int diff_lat=(int)Math.sqrt(Distance(A,B));
	A[0]=0;
	A[1]=(points.get(0).getLog());
	
	B[0]=0;
	B[1]=(points.get(points.size()-1).getLog());
	int diff_long=(int)Math.sqrt(Distance(A,B));
	
	bwr.append(""+diff_lat+";");
	bwr.append(""+diff_long+";");
	bwr.close();
}


/*
 * prvy sposob ratania vlastnosti celkoveho pokrytia (velmi velmi zdlahavy). Pre kazdy bod z oblasti celeho tracku prechadzame vsetky jednotlive
 * cesty a pocitame vzdialenost bodu od cesty 
 * 
public static void coverage() throws Exception{	
	boolean w_append;
	int w=max_long+(2*variance)+1-min_long;
	int h=max_lat+(2*variance)+1-min_lat;
	File actualFile2 = new File (dir,"total_Cover.txt");
	if (!actualFile2.exists())
		w_append=false;
	else w_append=true;
	BufferedWriter bwr=new BufferedWriter(new FileWriter(actualFile2,w_append));
	System.out.println(h+" "+w);
	
	boolean[][] cover=new boolean[h][w];
	for (int i=0; i<h;i++)
		for (int j=0; j<w;j++) {
			cover[i][j]=false;
		}
	int[] A = new int[2];
    int[] B = new int[2];
    int[] C = new int[2];
	
    long distance;
	
    for (int i=0; i<h;i++){
		for (int j=0; j<w;j++) {
			C[0]=i;
			C[1]=j;
			if (cover[i][j]) {
				continue; 
			} else {
			A[0]=(int)points.get(0).getLat()-min_lat+variance;
			A[1]=(int)points.get(0).getLog()-min_long+variance;	
			for (int p=0;p<points.size()-1;p++)
		    {	
				B[0]=(int)points.get(p+1).getLat()-min_lat+variance;
				B[1]=(int)points.get(p+1).getLog()-min_long+variance;
				
				distance=(int)Math.floor(LineToPointDistance2D(A,B,C,true));
				if (distance<variance2) {
					cover[i][j]=true;
					break;
				}
				A[0]=B[0];
				A[1]=B[1];
		    }
			}			
		}
    }
	
	long cover_sum=0;
	for (int i=0; i<h;i++){
		for (int j=0; j<w;j++){ 
			if (cover[i][j]) {
				cover_sum++;
				if(cover[i][j]) System.out.print(0); else System.out.print(1);  //vymaz
			}
		}
		System.out.println(";"); //vymaz
	}
	bwr.append(""+cover_sum+";");
	bwr.close();
}
*/



/**metoda pocitajuca vlastnost celkove pokrytie pricom bereme do uvahy dosah signalu mobilneho uzla @variance
 * vezmeme si oblast(bitmapu) max_lat+(2*variance), max_long+(2*variance). nasledne prechadzame jednoltive cesty. Pre kazdu oblast si vezmeme
 * jej (obldznikovu) oblast na ktoru by mohla mat dopad teda oblast (min_lat-variance,min_long-variance) az (max_lat+variance,max_long+variance) 
 * {max, min vyberame len z dvoch bodou cesty}. Pre kazdy bod v tejto oblasti zratame vzdialenost od tejto cesty, ak je mensia ako variance
 * tento bod je v pokryti, v bitmapemu nastavime hodnotu true (body s hodnotou true rovno preskakujeme a neratame vzdialenost).
 * Na koniec pozreme celu bitmapu a spocitame kolko bodov bolo v pokryti, hodnotu zapiseme do suboru. 
 *  */
public static void coverage1() throws Exception{	
	boolean w_append;
	File actualFile2 = new File (dir,"total_Cover_"+dir.getName()+".txt");
	if (!actualFile2.exists())
		w_append=false;
	else w_append=true;
	BufferedWriter bwr=new BufferedWriter(new FileWriter(actualFile2,w_append));
	
	int total_h=max_lat+(2*variance)+1;
	int total_w=max_long+(2*variance)+1;
	
	boolean[][] cover=new boolean[total_h][total_w];
	
	for (int i=0; i<total_h;i++)
		for (int j=0; j<total_w;j++) 
			cover[i][j]=false;
	
	long distance;
	int hlat,hlog,dlat,dlog;
	
	int[] A = new int[2];
	int[] B = new int[2];
	int[] C = new int[2];

	A[0]=(int)points.get(0).getLat()+variance;
	A[1]=(int)points.get(0).getLog()+variance;

	for (int p=0;p<points.size()-1;p++){
		
		B[0]=(int)points.get(p+1).getLat()+variance;
		B[1]=(int)points.get(p+1).getLog()+variance;
		if (A[0]<B[0]) {
			hlat=A[0];
			dlat=B[0];
		}else {
			hlat=B[0];
			dlat=A[0];
		}
		if (A[1]<B[1]) {
			hlog=A[1];
			dlog=B[1];
		}else {
			hlog=B[1];
			dlog=A[1];
		}
		
		int w=dlog+variance+1;
		int h=dlat+variance+1;
		
		for (int i=hlat-variance; i<h;i++){
			for (int j=hlog-variance; j<w;j++) {
			C[0]=i;
			C[1]=j;
			if (cover[i][j]) {
				continue; 
			} else {
				distance=(int)Math.floor(LineToPointDistance2D(A,B,C,true));
				if (distance<variance2) {
					cover[i][j]=true;
				}
			}
			}
		}
		A[0]=B[0];
		A[1]=B[1];
	}

	long cover_sum=0;
	for (int i=0; i<total_h;i++){
		for (int j=0; j<total_w;j++){ 
			if (cover[i][j]) {
				cover_sum++;
			}
		}
	}
	bwr.append(""+cover_sum+";");
	bwr.close();	
}

}
